//v0.1
//Added Reverse Mode
//Made initialization screen easier to access
//Trying to make an account at the moment

setInfos(6, "Yet Another Fond of Writing Clone", "My attempt at a flexible-ish Fond of Writing clone.", "Subbinator3000", "v0.1", 0xFFFFFF, "en", ["lines", "fun", "really"]);

def input = ""
def init = {
	//Explanatory blurb
	if(!loadString("yafowc.line1")){
		show("Welcome, "+loadString("intro.name")+".\nIt looks like this is your first time using this script.")
	}else{
		show("Welcome back, "+loadString("intro.name")+".\n")
	}
	showButton("Continue")
	show("We're going to do some basic configuration to get you ready. You can return to this section again anytime by choosing 'init' from the main menu.")
	showButton("Continue")
	show("This script lets you define the number of lines you want to type, the text of the lines you want to type, as well as the number of times you want to type each line. Capitalization matters, so be careful!") 
	showButton("Continue")

	//Defining number of lines
	def tempInt = getInteger("So, to start off, how many different lines do you want to have to type? This number must be at least 1.",1)
	if(tempInt < 1){
		while(tempInt < 1){
			tempInt = getInteger(loadString("intro.name")+", it's gotta be at least 1.",1)
		}
	}
	save("yafowc.numOfLines",tempInt)

	//Defining text for each line
	def tempString = ""
	for(def i=0;i<tempInt;i++){
		if(loadString("yafowc.line"+(i+1))){
			tempString = loadString("yafowc.line"+(i+1))
		}else{
			tempString = ""
		}
		input = getString("Now, what do you want line number "+(i+1)+" to be?",tempString)
		save("yafowc.line"+(i+1),input)
	}

	//Defining number of times each line is written
	tempInt = getInteger("Now, how many times do you want to write each line? This number must be at least 1.",1)
	if(tempInt < 1){
		while(tempInt < 1){
			tempInt = getInteger(loadString("intro.name")+", it's gotta be at least 1.",1)
		}
	}
	save("yafowc.needed",tempInt)

	show("Alright, you're all ready! Remember, you can always come back here by choosing 'init' from the main menu!")
	showButton("Continue")
	return null
}
if(!loadString("yafowc.line1")){
	init()
}else{	
//initialization
def options = ["Normal Mode","Reverse Mode","Init"]
def needed = loadInteger("yafowc.needed")
def numOfLines = loadInteger("yafowc.numOfLines")
def line = 0
def lines = new String[numOfLines]
def times = new Integer[numOfLines]
def rand = 0
for(def i=0; i<numOfLines; i++){
	lines[i] = loadString("yafowc.line"+(i+1))
	times[i] = needed
}

//0 is normal mode, type what you see
//1 is reverse mode, type what you see backwards, will be implemented soon-ish
//Want to add a hide mode, where you aren't shown what you type, but implementing that will be a bit harder
//The last one is always init
def mode = getSelectedValue("Welcome, "+loadString("intro.name")+".\nToday you will type "+needed*numOfLines+" lines.\nIf you make a mistake, you will have to write the line three more times.",options)
if (mode == 2){
	init()
	return null
}

for(def i=0; i<needed*numOfLines; i++){
	rand = getRandom(numOfLines)
	while(times[rand]==0){
		rand = getRandom(numOfLines)
	}
	times[rand]--
	input = getString(lines[rand], "")
	line = lines[rand]
	if(mode == 1){
		line = line.reverse()
	}

	if(input != line){
		show("That was incorrect. Write it three more times.")
		showButton("Continue")
		for(def j=0; j<3; j++){
			while(input != line){
				input = getString(lines[rand], "")
				if(input != line){
					show("Again.")
					wait(1)
				}
			}
			input = ""
		}
	}
	input = ""
}
show("Good job, you finished your lines for today.")
showButton("Done.")
}
// This script, from https://ss.deviatenow.com, is protected by this licence :
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/
